Package com.sap.ai.sdk.core.model

# Class AiExecutable

java.lang.Object
com.sap.ai.sdk.core.model.AiExecutable

public class AiExecutable extends Object
An ML executable consists of a set of ML tasks, flows between tasks, dependencies between tasks, models (or model versions?).

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static interface`
  `AiExecutable.Builder`
  Builder helper class.
  `static interface`
  `AiExecutable.Builder1`
  Builder helper class.
  `static interface`
  `AiExecutable.Builder2`
  Builder helper class.
  `static interface`
  `AiExecutable.Builder3`
  Builder helper class.
  `static interface`
  `AiExecutable.Builder4`
  Builder helper class.
  `static interface`
  `AiExecutable.Builder5`
  Builder helper class.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AiExecutable()`
  Default constructor for AiExecutable.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AiExecutable`
  `addInputArtifactsItem(AiExecutableArtifact inputArtifactsItem)`
  Add one inputArtifacts instance to this `AiExecutable`.
  `AiExecutable`
  `addLabelsItem(AiLabel labelsItem)`
  Add one labels instance to this `AiExecutable`.
  `AiExecutable`
  `addOutputArtifactsItem(AiExecutableArtifact outputArtifactsItem)`
  Add one outputArtifacts instance to this `AiExecutable`.
  `AiExecutable`
  `addParametersItem(AiExecutableParameter parametersItem)`
  Add one parameters instance to this `AiExecutable`.
  `static AiExecutable.Builder`
  `create()`
  Create a type-safe, fluent-api builder object to construct a new `AiExecutable` instance with all required arguments.
  `AiExecutable`
  `createdAt(OffsetDateTime createdAt)`
  Set the createdAt of this `AiExecutable` instance and return the same instance.
  `AiExecutable`
  `deployable(Boolean deployable)`
  Set the deployable of this `AiExecutable` instance and return the same instance.
  `AiExecutable`
  `description(String description)`
  Set the description of this `AiExecutable` instance and return the same instance.
  `boolean`
  `equals(Object o)`
  `OffsetDateTime`
  `getCreatedAt()`
  Timestamp of resource creation
  `Object`
  `getCustomField(String name)`
  Deprecated.
  Use `toMap()` instead.
  `Set<String>`
  `getCustomFieldNames()`
  Get the names of the unrecognizable properties of the `AiExecutable`.
  `String`
  `getDescription()`
  Description of the executable
  `String`
  `getId()`
  ID of the executable
  `List<AiExecutableArtifact>`
  `getInputArtifacts()`
  Executable parameters
  `List<AiLabel>`
  `getLabels()`
  Arbitrary labels as meta information
  `OffsetDateTime`
  `getModifiedAt()`
  Timestamp of latest resource modification
  `String`
  `getName()`
  Name of the executable
  `List<AiExecutableArtifact>`
  `getOutputArtifacts()`
  Executable parameters
  `List<AiExecutableParameter>`
  `getParameters()`
  Executable parameters
  `String`
  `getScenarioId()`
  ID of the scenario
  `String`
  `getVersionId()`
  Version ID
  `int`
  `hashCode()`
  `AiExecutable`
  `id(String id)`
  Set the id of this `AiExecutable` instance and return the same instance.
  `AiExecutable`
  `inputArtifacts(List<AiExecutableArtifact> inputArtifacts)`
  Set the inputArtifacts of this `AiExecutable` instance and return the same instance.
  `Boolean`
  `isDeployable()`
  Whether this executable is deployable
  `AiExecutable`
  `labels(List<AiLabel> labels)`
  Set the labels of this `AiExecutable` instance and return the same instance.
  `AiExecutable`
  `modifiedAt(OffsetDateTime modifiedAt)`
  Set the modifiedAt of this `AiExecutable` instance and return the same instance.
  `AiExecutable`
  `name(String name)`
  Set the name of this `AiExecutable` instance and return the same instance.
  `AiExecutable`
  `outputArtifacts(List<AiExecutableArtifact> outputArtifacts)`
  Set the outputArtifacts of this `AiExecutable` instance and return the same instance.
  `AiExecutable`
  `parameters(List<AiExecutableParameter> parameters)`
  Set the parameters of this `AiExecutable` instance and return the same instance.
  `AiExecutable`
  `scenarioId(String scenarioId)`
  Set the scenarioId of this `AiExecutable` instance and return the same instance.
  `void`
  `setCreatedAt(OffsetDateTime createdAt)`
  Set the createdAt of this `AiExecutable` instance.
  `void`
  `setCustomField(String customFieldName, Object customFieldValue)`
  Set an unrecognizable property of this `AiExecutable` instance.
  `void`
  `setDeployable(Boolean deployable)`
  Set the deployable of this `AiExecutable` instance.
  `void`
  `setDescription(String description)`
  Set the description of this `AiExecutable` instance.
  `void`
  `setId(String id)`
  Set the id of this `AiExecutable` instance.
  `void`
  `setInputArtifacts(List<AiExecutableArtifact> inputArtifacts)`
  Set the inputArtifacts of this `AiExecutable` instance.
  `void`
  `setLabels(List<AiLabel> labels)`
  Set the labels of this `AiExecutable` instance.
  `void`
  `setModifiedAt(OffsetDateTime modifiedAt)`
  Set the modifiedAt of this `AiExecutable` instance.
  `void`
  `setName(String name)`
  Set the name of this `AiExecutable` instance.
  `void`
  `setOutputArtifacts(List<AiExecutableArtifact> outputArtifacts)`
  Set the outputArtifacts of this `AiExecutable` instance.
  `void`
  `setParameters(List<AiExecutableParameter> parameters)`
  Set the parameters of this `AiExecutable` instance.
  `void`
  `setScenarioId(String scenarioId)`
  Set the scenarioId of this `AiExecutable` instance.
  `void`
  `setVersionId(String versionId)`
  Set the versionId of this `AiExecutable` instance.
  `Map<String,Object>`
  `toMap()`
  Get the value of all properties of this `AiExecutable` instance including unrecognized properties.
  `String`
  `toString()`
  `AiExecutable`
  `versionId(String versionId)`
  Set the versionId of this `AiExecutable` instance and return the same instance.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### AiExecutable

    protected AiExecutable()
    Default constructor for AiExecutable.

- ## Method Details

  - ### labels

    @Nonnull public AiExecutable labels(@Nullable List<AiLabel> labels)
    Set the labels of this `AiExecutable` instance and return the same instance.
    Parameters:
      `labels` - Arbitrary labels as meta information
    Returns:
      The same instance of this `AiExecutable` class

  - ### addLabelsItem

    @Nonnull public AiExecutable addLabelsItem(@Nonnull AiLabel labelsItem)
    Add one labels instance to this `AiExecutable`.
    Parameters:
      `labelsItem` - The labels that should be added
    Returns:
      The same instance of type `AiExecutable`

  - ### getLabels

    @Nonnull public List<AiLabel> getLabels()
    Arbitrary labels as meta information
    Returns:
      labels The labels of this `AiExecutable` instance.

  - ### setLabels

    public void setLabels(@Nullable List<AiLabel> labels)
    Set the labels of this `AiExecutable` instance.
    Parameters:
      `labels` - Arbitrary labels as meta information

  - ### name

    @Nonnull public AiExecutable name(@Nonnull String name)
    Set the name of this `AiExecutable` instance and return the same instance.
    Parameters:
      `name` - Name of the executable
    Returns:
      The same instance of this `AiExecutable` class

  - ### getName

    @Nonnull public String getName()
    Name of the executable
    Returns:
      name The name of this `AiExecutable` instance.

  - ### setName

    public void setName(@Nonnull String name)
    Set the name of this `AiExecutable` instance.
    Parameters:
      `name` - Name of the executable

  - ### description

    @Nonnull public AiExecutable description(@Nullable String description)
    Set the description of this `AiExecutable` instance and return the same instance.
    Parameters:
      `description` - Description of the executable
    Returns:
      The same instance of this `AiExecutable` class

  - ### getDescription

    @Nonnull public String getDescription()
    Description of the executable
    Returns:
      description The description of this `AiExecutable` instance.

  - ### setDescription

    public void setDescription(@Nullable String description)
    Set the description of this `AiExecutable` instance.
    Parameters:
      `description` - Description of the executable

  - ### id

    @Nonnull public AiExecutable id(@Nonnull String id)
    Set the id of this `AiExecutable` instance and return the same instance.
    Parameters:
      `id` - ID of the executable
    Returns:
      The same instance of this `AiExecutable` class

  - ### getId

    @Nonnull public String getId()
    ID of the executable
    Returns:
      id The id of this `AiExecutable` instance.

  - ### setId

    public void setId(@Nonnull String id)
    Set the id of this `AiExecutable` instance.
    Parameters:
      `id` - ID of the executable

  - ### scenarioId

    @Nonnull public AiExecutable scenarioId(@Nullable String scenarioId)
    Set the scenarioId of this `AiExecutable` instance and return the same instance.
    Parameters:
      `scenarioId` - ID of the scenario
    Returns:
      The same instance of this `AiExecutable` class

  - ### getScenarioId

    @Nonnull public String getScenarioId()
    ID of the scenario
    Returns:
      scenarioId The scenarioId of this `AiExecutable` instance.

  - ### setScenarioId

    public void setScenarioId(@Nullable String scenarioId)
    Set the scenarioId of this `AiExecutable` instance.
    Parameters:
      `scenarioId` - ID of the scenario

  - ### versionId

    @Nonnull public AiExecutable versionId(@Nonnull String versionId)
    Set the versionId of this `AiExecutable` instance and return the same instance.
    Parameters:
      `versionId` - Version ID
    Returns:
      The same instance of this `AiExecutable` class

  - ### getVersionId

    @Nonnull public String getVersionId()
    Version ID
    Returns:
      versionId The versionId of this `AiExecutable` instance.

  - ### setVersionId

    public void setVersionId(@Nonnull String versionId)
    Set the versionId of this `AiExecutable` instance.
    Parameters:
      `versionId` - Version ID

  - ### parameters

    @Nonnull public AiExecutable parameters(@Nullable List<AiExecutableParameter> parameters)
    Set the parameters of this `AiExecutable` instance and return the same instance.
    Parameters:
      `parameters` - Executable parameters
    Returns:
      The same instance of this `AiExecutable` class

  - ### addParametersItem

    @Nonnull public AiExecutable addParametersItem(@Nonnull AiExecutableParameter parametersItem)
    Add one parameters instance to this `AiExecutable`.
    Parameters:
      `parametersItem` - The parameters that should be added
    Returns:
      The same instance of type `AiExecutable`

  - ### getParameters

    @Nonnull public List<AiExecutableParameter> getParameters()
    Executable parameters
    Returns:
      parameters The parameters of this `AiExecutable` instance.

  - ### setParameters

    public void setParameters(@Nullable List<AiExecutableParameter> parameters)
    Set the parameters of this `AiExecutable` instance.
    Parameters:
      `parameters` - Executable parameters

  - ### inputArtifacts

    @Nonnull public AiExecutable inputArtifacts(@Nullable List<AiExecutableArtifact> inputArtifacts)
    Set the inputArtifacts of this `AiExecutable` instance and return the same instance.
    Parameters:
      `inputArtifacts` - Executable parameters
    Returns:
      The same instance of this `AiExecutable` class

  - ### addInputArtifactsItem

    @Nonnull public AiExecutable addInputArtifactsItem(@Nonnull AiExecutableArtifact inputArtifactsItem)
    Add one inputArtifacts instance to this `AiExecutable`.
    Parameters:
      `inputArtifactsItem` - The inputArtifacts that should be added
    Returns:
      The same instance of type `AiExecutable`

  - ### getInputArtifacts

    @Nonnull public List<AiExecutableArtifact> getInputArtifacts()
    Executable parameters
    Returns:
      inputArtifacts The inputArtifacts of this `AiExecutable` instance.

  - ### setInputArtifacts

    public void setInputArtifacts(@Nullable List<AiExecutableArtifact> inputArtifacts)
    Set the inputArtifacts of this `AiExecutable` instance.
    Parameters:
      `inputArtifacts` - Executable parameters

  - ### outputArtifacts

    @Nonnull public AiExecutable outputArtifacts(@Nullable List<AiExecutableArtifact> outputArtifacts)
    Set the outputArtifacts of this `AiExecutable` instance and return the same instance.
    Parameters:
      `outputArtifacts` - Executable parameters
    Returns:
      The same instance of this `AiExecutable` class

  - ### addOutputArtifactsItem

    @Nonnull public AiExecutable addOutputArtifactsItem(@Nonnull AiExecutableArtifact outputArtifactsItem)
    Add one outputArtifacts instance to this `AiExecutable`.
    Parameters:
      `outputArtifactsItem` - The outputArtifacts that should be added
    Returns:
      The same instance of type `AiExecutable`

  - ### getOutputArtifacts

    @Nonnull public List<AiExecutableArtifact> getOutputArtifacts()
    Executable parameters
    Returns:
      outputArtifacts The outputArtifacts of this `AiExecutable` instance.

  - ### setOutputArtifacts

    public void setOutputArtifacts(@Nullable List<AiExecutableArtifact> outputArtifacts)
    Set the outputArtifacts of this `AiExecutable` instance.
    Parameters:
      `outputArtifacts` - Executable parameters

  - ### deployable

    @Nonnull public AiExecutable deployable(@Nonnull Boolean deployable)
    Set the deployable of this `AiExecutable` instance and return the same instance.
    Parameters:
      `deployable` - Whether this executable is deployable
    Returns:
      The same instance of this `AiExecutable` class

  - ### isDeployable

    @Nonnull public Boolean isDeployable()
    Whether this executable is deployable
    Returns:
      deployable The deployable of this `AiExecutable` instance.

  - ### setDeployable

    public void setDeployable(@Nonnull Boolean deployable)
    Set the deployable of this `AiExecutable` instance.
    Parameters:
      `deployable` - Whether this executable is deployable

  - ### createdAt

    @Nonnull public AiExecutable createdAt(@Nonnull OffsetDateTime createdAt)
    Set the createdAt of this `AiExecutable` instance and return the same instance.
    Parameters:
      `createdAt` - Timestamp of resource creation
    Returns:
      The same instance of this `AiExecutable` class

  - ### getCreatedAt

    @Nonnull public OffsetDateTime getCreatedAt()
    Timestamp of resource creation
    Returns:
      createdAt The createdAt of this `AiExecutable` instance.

  - ### setCreatedAt

    public void setCreatedAt(@Nonnull OffsetDateTime createdAt)
    Set the createdAt of this `AiExecutable` instance.
    Parameters:
      `createdAt` - Timestamp of resource creation

  - ### modifiedAt

    @Nonnull public AiExecutable modifiedAt(@Nonnull OffsetDateTime modifiedAt)
    Set the modifiedAt of this `AiExecutable` instance and return the same instance.
    Parameters:
      `modifiedAt` - Timestamp of latest resource modification
    Returns:
      The same instance of this `AiExecutable` class

  - ### getModifiedAt

    @Nonnull public OffsetDateTime getModifiedAt()
    Timestamp of latest resource modification
    Returns:
      modifiedAt The modifiedAt of this `AiExecutable` instance.

  - ### setModifiedAt

    public void setModifiedAt(@Nonnull OffsetDateTime modifiedAt)
    Set the modifiedAt of this `AiExecutable` instance.
    Parameters:
      `modifiedAt` - Timestamp of latest resource modification

  - ### getCustomFieldNames

    @Nonnull public Set<String> getCustomFieldNames()
    Get the names of the unrecognizable properties of the `AiExecutable`.
    Returns:
      The set of properties names

  - ### getCustomField

    @Nullable @Deprecated public Object getCustomField(@Nonnull String name) throws NoSuchElementException
    Deprecated.
    Use `toMap()` instead.
    Get the value of an unrecognizable property of this `AiExecutable` instance.
    Parameters:
      `name` - The name of the property
    Returns:
      The value of the property
    Throws:
      `NoSuchElementException` - If no property with the given name could be found.

  - ### toMap

    @Nonnull public Map<String,Object> toMap()
    Get the value of all properties of this `AiExecutable` instance including unrecognized properties.
    Returns:
      The map of all properties

  - ### setCustomField

    public void setCustomField(@Nonnull String customFieldName, @Nullable Object customFieldValue)
    Set an unrecognizable property of this `AiExecutable` instance. If the map previously contained a mapping for the key, the old value is replaced by the specified value.
    Parameters:
      `customFieldName` - The name of the property
      `customFieldValue` - The value of the property

  - ### equals

    public boolean equals(@Nullable Object o)
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    @Nonnull public String toString()
    Overrides:
      `toString` in class `Object`

  - ### create

    public static AiExecutable.Builder create()
    Create a type-safe, fluent-api builder object to construct a new `AiExecutable` instance with all required arguments.